/*
    mcontrol
       000    ldw  stw
       001    ldb  stb
       010    ldh  sth
       101    ldbu
       110    ldhu
*/

module mformat(op,mcontrol);
input [5:0] op;
output [2:0] mcontrol;

reg [2:0] mcontrol;

always
	case (op)
	6'h03: mcontrol = 3'h5; // ldbu
	6'h05: mcontrol = 3'h1; // stb
	6'h07: mcontrol = 3'h1; // ldb
	6'h0b: mcontrol = 3'h6; // ldhu
	6'h0d: mcontrol = 3'h2; // sth
	6'h0f: mcontrol = 3'h2; // ldh
	6'h15: mcontrol = 3'h0; // stw
	6'h17: mcontrol = 3'h0; // ldw
	6'h23: mcontrol = 3'h5; // ldbuio
	6'h25: mcontrol = 3'h1; // stbio
	6'h2b: mcontrol = 3'h6; // ldhuio
	6'h2d: mcontrol = 3'h2; // sthio
	6'h2f: mcontrol = 3'h2; // ldhio
	6'h35: mcontrol = 3'h0; // stwio
	6'h37: mcontrol = 3'h0; // ldwio
	default: mcontrol = 3'h0;
	endcase
	
endmodule