/*
*   select[:
*    000  32-bit word
*    001  8-bit byte (se)
*    010  16-bit half-word (se)
*    101  8-bit byte (unsigned)
*    110  16-bit half-word (unsigned)
*/  
module mselect(output reg [31:0] out, input [31:0] mq, input [2:0] select, input[1:0] addr);

wire se;
assign se = !select[2];

always
	case (select[1:0])
	2'b01: 
		case (addr)
		2'b00: out <= {{24{mq[7]&se}},mq[7:0]};
		2'b01: out <= {{24{mq[15]&se}},mq[15:8]};
		2'b10: out <= {{24{mq[23]&se}},mq[23:16]};
		2'b11: out <= {{24{mq[31]&se}},mq[31:24]};
		endcase
	2'b10:
		if (addr[1]) out <= {{16{mq[31]&se}},mq[31:16]};
		else out <= {{16{mq[15]&se}},mq[15:0]};
	default: out <= mq;
	endcase
endmodule
